
class RTPCMediator implements IRTPCMediator {
	private Vehicle vehicle;
	private Road road;
	public boolean start, stop;

	public void registerRoad(Road road) {
		this.road= road;
	}

	public void registerVehicle(Vehicle vehicle) {
		this.vehicle= vehicle;
	}

	public boolean isStarted() {
		return start;
	}

        public boolean isStopped() {
		return stop;
	}

	@Override
	public void setStartedStatus(boolean status) {
		start= status;

	}
        
        @Override
	public void setStoppedStatus(boolean status) {
		stop= status;

	}
}

interface Statement{
	void start();

        void stop();
}

interface IRTPCMediator {

	public void registerRoad(Road road);

	public void registerVehicle(Vehicle vehicle);

	public boolean isStarted();
        
        public boolean isStopped();

	public void setStartedStatus(boolean status);

        public void setStoppedStatus(boolean status);
}

class Vehicle implements Statement{
	private IRTPCMediator rtpcMediator;

	public Vehicle(IRTPCMediator rtpcMediator) {
		this.rtpcMediator = rtpcMediator;
	}

	public void start() {
		if (rtpcMediator.isStopped()) {
			System.out.println("Started....");
			rtpcMediator.setStartedStatus(true);
		} else
			System.out.println("Will wait to start....");
	}

        public void stop() {
		if (rtpcMediator.isStopped()) {
			System.out.println("Stopped....");
			rtpcMediator.setStoppedStatus(true);
		} else
			System.out.println("Will wait to stop....");
	}

	public void getReady() {
		System.out.println("Getting ready...");
	}

}

class Road implements Statement{
	private IRTPCMediator rtpcMediator;

	public Road(IRTPCMediator rtpcMediator2) {
		this.rtpcMediator= rtpcMediator2;
		rtpcMediator2.setStartedStatus(true);
	}

	@Override
	public void start() {
		System.out.println("Starting permission granted...");
		rtpcMediator.setStartedStatus(true);
	}

        @Override
	public void stop() {
		System.out.println("Stopping permission granted...");
		rtpcMediator.setStoppedStatus(true);
	}

}

public class MediatorDesignPattern {
	public static void main(String args[]) {

		IRTPCMediator rtpcMediator = new RTPCMediator();
		Vehicle marutisuzuki= new Vehicle(rtpcMediator);
		Road mgroad= new Road(rtpcMediator);
		rtpcMediator.registerVehicle(marutisuzuki);
		rtpcMediator.registerRoad(mgroad);
		marutisuzuki.getReady();
		mgroad.start();
		marutisuzuki.start();
                marutisuzuki.stop();
	}
}
